SystemOrganization addCategory: #'FuelPlatform-Pharo-03'!

FLPharoPlatform subclass: #FLPharo3Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform-Pharo-03'!

!FLPharo3Platform class methodsFor: 'private-hacks' stamp: 'MaxLeske 4/30/2016 14:09'!
addAbstractBinaryFileStream
	Smalltalk
		at: #AbstractBinaryFileStream
		ifPresent: [ :x | ^ self ].
		
	Stream subclass: #AbstractBinaryFileStream
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName! !

!FLPharo3Platform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/21/2016 15:17'!
addContext
	Smalltalk
		at: #Context
		ifPresent: [ :x | ^ self ].
		
	Object 
		subclass: #Context
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName! !

!FLPharo3Platform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/22/2016 21:04'!
addHacks
	(Smalltalk at: #SystemAnnouncer) uniqueInstance suspendAllWhile: [
		RPackageOrganizer default
			registerPackageNamed: self hacksCategoryName;
			registerPackageNamed: self extensionCategoryName.
		super addHacks ]! !

!FLPharo3Platform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/21/2016 15:48'!
assertWellMaterializedInto: aMethodContext in: aTestCase
	<flExtensionOf: #MethodContext isSource: true>
	^ 'assertWellMaterializedInto: aMethodContext in: aTestCase

	aTestCase assert: self ~~ aMethodContext. 
	aTestCase assert: (self class == aMethodContext class).
	aTestCase assert: self tempNames = aMethodContext  tempNames.
	aTestCase assert: pc = aMethodContext pc.
	aTestCase assert: stackp = aMethodContext stackPtr.
	closureOrNil isNil 
		ifTrue: [ aTestCase assert: aMethodContext closure isNil ]
		ifFalse: [ closureOrNil assertWellMaterializedInto: aMethodContext closure in: aTestCase ].
	aTestCase assert: receiver = aMethodContext receiver.
	aTestCase assert: (method isEqualRegardlessTrailerTo: aMethodContext method).
	sender isNil 
		ifTrue: [ aTestCase assert: aMethodContext sender isNil ]
		ifFalse: [ sender assertWellMaterializedInto: aMethodContext sender in: aTestCase ]'! !

!FLPharo3Platform class methodsFor: 'private-hacks' stamp: 'MaxLeske 4/30/2016 14:10'!
basicAddHacks
	super basicAddHacks.
	
	self
		addContext;
		addAbstractBinaryFileStream! !

!FLPharo3Platform class methodsFor: 'private-extensions-flexecutionbenchmarks' stamp: 'MaxLeske 2/22/2016 21:23'!
benchs
	<flExtensionOf: #FLExecutionBenchmarks>
	<flExtensionClassSide>
	(self class selectorsInProtocol: 'executing')
		do: [:m |
			Transcript 
				cr; 
				show: m printString;
				show: '->'.
			[self perform: m] bench printOn: Transcript ].
	Transcript flush! !

!FLPharo3Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/21/2016 14:38'!
cleanCopyForBlockClosure
	<flExtensionOf: #BlockClosure selector: #cleanCopy>
	"Answer a copy of myself preserving in outerContext just the receiver and method, which are the only needed by a clean block closure."

	^ self shallowCopy
		cleanOuterContext;
		yourself! !

!FLPharo3Platform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/21/2016 14:38'!
cleanCopyForMethodContext
	<flExtensionOf: #MethodContext selector: #cleanCopy isSource: true>
	^ 'cleanCopy 

	^ self class 
		sender: nil 
		receiver: receiver 
		method: method
		arguments: #()'! !

!FLPharo3Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/21/2016 14:37'!
cleanOuterContext
	<flExtensionOf: #BlockClosure isSource: true>
	^ 'cleanOuterContext
	"Clean my outerContext preserving just the receiver and method, which are the only needed by a clean block closure."

	outerContext := outerContext cleanCopy'! !

!FLPharo3Platform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/21/2016 17:30'!
fuelAcceptForMethodContext: aGeneralMapper
	<flExtensionOf: #MethodContext selector: #fuelAccept:>
	^aGeneralMapper visitMethodContext: self! !

!FLPharo3Platform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/21/2016 15:47'!
initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	<flExtensionOf: #MethodContext isSource: true>
	^ 'initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	pc := aPc.
	stackp := aStackPtr.
	method := aMethod.
	receiver := aReceiver.
	sender := aSender'! !

!FLPharo3Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/21/2016 15:16'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Pharo3' ]! !

!FLPharo3Platform class methodsFor: 'private-extensions-contextpart' stamp: 'MaxLeske 2/21/2016 15:44'!
newFromFrameSize: aFrameSize
	<flExtensionOf: #ContextPart>
	<flExtensionClassSide>
	^ super basicNew: aFrameSize! !

!FLPharo3Platform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/22/2016 22:30'!
tearDownTraits
	<flExtensionOf: #FLSerializationTest>
	(Smalltalk at: #SystemAnnouncer) uniqueInstance suspendAllWhile: [
		self cleanUpTraits ]! !

!FLPharo3Platform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContext
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: 23
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLPharo3Platform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithClosureAndSender
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext2 context2 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: 23
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	context2 := self class blockClosureContextTestingWithSender: context1.
	materializedContext2 := self
		resultOfSerializeAndMaterialize: context2.
	context2 assertWellMaterializedInto: materializedContext2 in: self! !

!FLPharo3Platform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithNilPc
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: nil
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLPharo3Platform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithSender
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 context2 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: 23
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	context2 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method2.
	context2
		initializeWith: 18
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method2
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 5;
				left: 6)
		sender: nil.
	context1 privSender: context2.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLPharo3Platform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithTemp
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #methodWithTemp.
	context1
		initializeWith: nil
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #methodWithTemp
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	context1 tempNamed: 'string' put: 'capo'.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	self assert: (materializedContext1 tempNamed: 'string') = 'capo'.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLPharo3Platform methodsFor: 'accessing-files' stamp: 'MaxLeske 4/30/2016 12:35'!
deleteFileNamed: aFilename
	aFilename asFileReference delete! !

!FLPharo3Platform methodsFor: 'accessing-files' stamp: 'MaxLeske 4/29/2016 09:10'!
fileNamed: aFileame readStreamDo: aBlock
	^ aFileame asFileReference readStreamDo: [ :stream |
		stream binary.
		aBlock value: stream ]! !

!FLPharo3Platform methodsFor: 'testing' stamp: 'MaxLeske 2/21/2016 15:17'!
isBigEndian
	^ Smalltalk isBigEndian! !

!FLPharo3Platform methodsFor: 'testing' stamp: 'MaxLeske 2/21/2016 15:15'!
isSpur
	^ false! !
